
c---------------------------------------------------------------------
c---------------------------------------------------------------------

      subroutine setbv

c---------------------------------------------------------------------
c---------------------------------------------------------------------

c---------------------------------------------------------------------
c   set the boundary values of dependent variables
c---------------------------------------------------------------------

      implicit none

      include 'applu.incl'

c---------------------------------------------------------------------
c   local variables
c---------------------------------------------------------------------
      integer i, j, k
      integer iglob, jglob

      integer ii
      double precision dtemp(5)
!HPF$ sequence dtemp

      interface
         pure extrinsic(FORTRAN_LOCAL)
     >     subroutine exact( i, j, k, u000ijk )
         integer i, j, k
         double precision u000ijk(*)
         end subroutine
      end interface

c---------------------------------------------------------------------
c   set the dependent variable values along the top and bottom faces
c---------------------------------------------------------------------
!HPF$ independent
      do j = 1, ny
         jglob = j
         do i = 1, nx
           iglob = i
            call exact( iglob, jglob, 1, dtemp )
            do ii=1, 5
               u( ii, i, j, 1 ) = dtemp(ii)
            end do
            call exact( iglob, jglob, nz, dtemp )
            do ii=1, 5
               u( ii, i, j, nz ) = dtemp(ii)
            end do
         end do
      end do

c---------------------------------------------------------------------
c   set the dependent variable values along north and south faces
c---------------------------------------------------------------------
!HPF$ on home(u(:,:,1,:)), local begin
      do k = 1, nz
         do i = 1, nx
            iglob = i
            call exact( iglob, 1, k, dtemp )
            do ii=1, 5
               u( ii, i, 1, k ) = dtemp(ii)
            end do
         end do
      end do
!HPF$ end on

!HPF$ on home(u(:,:,ny,:)), local begin
       do k = 1, nz
          do i = 1, nx
             iglob = i
             call exact( iglob, ny0, k, dtemp )
             do ii=1, 5
                u( ii, i, ny, k ) = dtemp(ii)
             end do
          end do
       end do
!HPF$ end on

c---------------------------------------------------------------------
c   set the dependent variable values along east and west faces
c---------------------------------------------------------------------
      do k = 1, nz
!HPF$    independent
         do j = 1, ny
            jglob = j
            call exact( 1, jglob, k, dtemp )
            do ii=1, 5
               u( ii, 1, j, k ) = dtemp(ii)
            end do
         end do
      end do

      do k = 1, nz
!HPF$    independent
         do j = 1, ny
            jglob = j
            call exact( nx0, jglob, k, dtemp )
            do ii=1, 5
               u( ii, nx, j, k ) = dtemp(ii)
            end do
         end do
      end do

      return
      end
